!
! Vintegrals --- access to Wannier98 Fock and two-electron integrals
! Christian Buth
! 02.10.2004
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!
!
! Version 1.00: 02.10.2004 (Martin Albrecht's Greens parameters
!       and common blocks integrated)
!


      module Vintegrals
      use fortrantl
      implicit none

!     PARAM.GREENS

!     ------- max# of orbitals and basis  functions: ------
      ! CB
      integer, parameter :: norbm=120
!      integer*8, parameter :: norbm=120
      ! END CB
!      integer, parameter :: nbasmred=norbm
      integer, parameter :: nbasmred=norbm**2
      integer, parameter :: ncellm=1

!     ------- dimension of the large arrays: ------
      ! CB
!      integer, parameter :: ndimarray=27000000
      integer(longint), parameter :: ndimarray=200000000
      ! END CB

      ! CB
!      integer, parameter :: nVXijklm = norbm*(norbm+1) / 2 &
!     &          *(norbm*(norbm+1)/2+1)
      integer(longint), parameter :: nVXijklm = 80000000
      ! END CB

      integer, parameter :: iout=6

!     ------- for the increment list: ---------------
      integer, parameter :: morbit=55
      integer, parameter :: mvector=500



!     COMMON.GREENS

!     ------- the big array is: ----------
      common/arrays/a(ndimarray)
        real(dblprec) a
!     ------- its pointers are: ----------
      common/pointa/iHF,iVijkl,iVXijkl,iBkt

!,iEV,iEVa,iMat,                                      &
!     &              iM1pointer,iOarray,iRarray,iParray,iNarray,iLarray,                         &
!     &              ifockbdA,ifockbdE,icorrbdA,icorrbdE,isatbdA,isatbdE,                        &
!     &              isigmaA,isigmaB,isigmaC,isigmaE
!      common/pointa2/iOvecC,iNvecC,iLvecC,iEVonC,iEVaaC,                                        &
!     &              iOvecV,iNvecV,iLvecV,iEVonV,iEVaaV,                                         &
!     &              iLarr,iNarr,iOarr,iEVs,iEVas,                                               &
!     &              iLarrG,iNarrG,iOarrG,iEVsG,iEVasG

      !  integer iHF,iVijkl,iVXijkl,iBkt
      ! CB
        integer iHF,iVijkl,iVXijkl,iBkt
      ! END CB


!     --- informing flags ---------
      common/infos/incwork,iterwork,ispectrum,icheck

      !  integer incwork,iterwork,ispectrum,icheck
      ! CB
        integer incwork,iterwork,ispectrum,icheck
      ! END CB


!     --- incremental variables and pointers ---------
!      common/incvar/ninc,iInc,idistribute
!      common/incpointers/incptr(nbasm)
!      common/incpointers2/icellpoint(nbasm)
!      common/incpointers3/icombcount,ishift,nclimit
!      COMMON /pointer/ itrgtp(ncellrm),istrtp(ncellrm),                                         &
!     &                iorbptr(nbasm),ibackptr(nbasm),                                           &
!     &                irohtab(nbasm*ncellrm)

!     ----------------
! CB : ncele hinzugefgt
      common/sizevar/norb,nocc,nbas,nrealcel,ncele
      common/deriv/nqorb
      common/Vijkl/ifla,nijklo
!      common/Vijkl2/fla
      !  integer nqorb, norb,nocc,nbas,nrealcel,ncele, ifla,nijklo
      ! CB
        integer nqorb, norb,nocc,nbas,nrealcel,ncele, ifla,nijklo
      ! END CB

!     --- the sign to switch between holes and particles ---------
!      common/signs/ isign
!      common/orblimitsA/n1a,n1e,n2a,n2e,n3a,n3e,m1a,m1e,m2a,m2e,m3a,m3e
!      common/orblimitsB/neffocca,neffocce,neffvirta,neffvirte
!      common/orblimitsD/n1d,n2d,n3d,m1d,m2d,m3d
!      common/orblimitsE/n1off,n3off
!      common/orblimitsF/ibandFstart,ibandFend

!     --- related values for the sigma-matrix ---------
!      common/orblimitsAs/ns1a,ns1e,ns2a,ns2e,ns3a,ns3e
!      common/orblimitsBs/nseffocca,nseffocce,nseffvirta,nseffvirte
!      common/orblimitsDs/ns1d,ns2d,ns3d
!      common/orblimitsEs/ns1off,ns3off
!      common/orblimitsFs/nsclimit,nsrealcel

!     ---- some dimensions -------------------------------------
!      common/dim/matspacedim,matgesdim,matges
!      common/kspace/kpoints,kstep
      common/vectors/nveclist
      !  integer nveclist
      ! CB
        integer nveclist
      ! END CB


!     ------- File-numbers ---------------
      common/filenumbers/iHFfile,iVfile,iVXfile,iBKTfile,iHFbandfile
        integer iHFfile,iVfile,iVXfile,iBKTfile,iHFbandfile
!     ------- File-names -----------------
      character(3) extension
      character(1) cv
      character(40) HFname,Vname,VXname,BKTname         ! ,HFbandname
      character(80) zeile
      common/filenames/HFname,Vname,VXname,BKTname,extension,zeile,cv
!      character*5 incname
!      common/incfiles/incname(nincmax)




        ! COMMON Blocks referred to in fallfind, fockall


      !! CB: common/ks/kval(3,mstep*npath,npath),kvec(3),abas(3,3)
      !DOUBLE PRECISION kval,kvec,kstauch,kstauch2
      common/ks/abas(3,3)
      integer abas
      ! END CB

      common/space2/ngroup,nsymop,nsyorb,nvmin,nvmax,isy,isyzahl
      common/syms2/ivgroup(mvector),ivecsym(mvector,mvector)
        integer ngroup,nsymop,nsyorb,nvmin,nvmax,isy,isyzahl, ivgroup, ivecsym

      common/fmat/Fockmat(2,mvector,morbit,morbit)
      common/smat/Sockmat(2,mvector,morbit,morbit)
        real(kind(0D0)) Fockmat, Sockmat

      common /vectors/ivec(mvector),nvlist(3,mvector)
        integer ivec, nvlist

      common/fockcut/nveccut,ivecmax
      common/sock/isockmat
        integer isockmat, nveccut,ivecmax

      common/fockallparam/ntpqpseudo,moccx,morbx,mzell
      integer ntpqpseudo,moccx,morbx,mzell


        ! readvijkl
      common/virtarrays/ ifillarray(nbasmred*(nbasmred+1)/2)
      common/recarrays/ irecstart(10*ncellm),irecend(10*ncellm)
      common /vparread/ ioffset,ibandrange
      !  integer ioffset,ibandrange, irecstart, irecend, ifillarray
      ! CB
        integer ioffset,ibandrange, irecstart, irecend, ifillarray
      ! END CB


        ! getvijkl
      common /twoint/ ijbuf(NBASMred*ncellm*(NBASMred*ncellm+1)/2),   &
     &                ijadd(NBASMred*ncellm*(NBASMred*ncellm+1)/2+1), &
     &                klbuf(nVXijklm)
      common /partint/ ijA1,ijE1
      common /twointpar/ ijcount,ixla
      !  integer ijbuf, ijadd, klbuf, ijA1,ijE1, ijcount,ixla
      ! CB
        integer ijbuf, ijadd, klbuf, ijA1,ijE1, ijcount,ixla
      ! END CB


!
! Interfaces
!

      interface
      real(dblprec) function fallfind(i,R,j)
        use fortrantl
        integer, intent(in) :: i, R, j
      end function fallfind


      real(dblprec) function ffind(i,j)
        use fortrantl
        integer, intent(in) :: i,j
      end function Ffind


      real(dblprec) function gfind(i, j, k, l)
        use fortrantl
        integer, intent(in) :: i, j, k, l
      end function gfind


      subroutine unpack2(ij, i, j)
        implicit none
        integer, intent(in) :: ij
        integer, intent(out) :: i, j
      end subroutine unpack2


      subroutine readhf(itask)
        implicit none
        integer, intent(in) :: itask
      end subroutine readhf


      subroutine getvijkl(mijklx, nrcount)
        implicit none
        integer, intent(in) :: mijklx, nrcount
      end subroutine getvijkl


      subroutine canonicorder(ip, iq, ir, is)
        implicit none
        integer, intent(inout) :: ip, iq, ir, is
      end subroutine canonicorder


      subroutine scanarray(ijarray,mdim,ij,ileft,iright,ipos)
        implicit none
        integer mdim, ijarray(:), ij,ileft,iright,ipos
      end subroutine scanarray
      end interface
      end module Vintegrals
