!
! ffind --- retrive a molecular two-electron matrix element
! Martin Albrecht
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!


      function gfind(i,j,k,l) result(gfindres)
!     ***************************************************************************
!     * NOTE: this fuction takes ijkl as the indices for g(ijkl)=v(ikjl) !!!!!! *
!     *       so the indices are interchanged now in this routine!!             *
!     ***************************************************************************

      use fortrantl
      use Vintegrals

!      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      implicit none

      integer i, j, k, l, ii, jj, kk, ll, ij, kl, illl, irrr, kleft, &
     &        kright, ipos, kpos

      ! CB include 'param_greens'
      ! CB include 'common_greens'

      real(dblprec) gfindres

      ii=i
      jj=k
      kk=j
      ll=l
      call canonicorder(ii,jj,kk,ll)
      ij=ii*(ii-1)/2+jj

      illl=1
      irrr=ijcount
      ! CB call scanarray(ijbuf(1),ijcount,ij,illl,irrr,ipos)
      call scanarray(ijbuf,ijcount,ij,illl,irrr,ipos)
!        write(iout,*)'ipos:',ii,jj,kk,ll,ipos

      if (ipos.eq.0) then
        gfindres=0
        return
!      else
!        write(iout,*)'ipos:',ii,jj,kk,ll,ipos
      end if

      kl=kk*(kk-1)/2+ll
      kleft=ijadd(ipos)
      kright=ijadd(ipos+1)-1
      ! CB call scanarray(klbuf(1),ixla,kl,kleft,kright,kpos)
      call scanarray(klbuf,ixla,kl,kleft,kright,kpos)
!        write(iout,*)'kpos:',ii,jj,kk,ll,kpos

      if (kpos.eq.0) then
        gfindres=0
        return
      end if

      gfindres=a(iVijkl+kpos-1)
      end function gfind
