!
! readvijkl --- manage loading of two-electron integerals
! Martin Albrecht
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!


!     *******************************
      subroutine readvijkl
!
!     kept in '~/greens/src'
!     *******************************

      use fortrantl
      use Vintegrals

! CB      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
! CB      IMPLICIT integer (I-N)
      implicit none

      integer idone, mefforb, morb, istartband, iendband, mcele, &
     &        nefforb, neffocca, neffocce, neffvirta, neffvirte, &
     &        nN1, nNORB, ifilldim, mijklx, if, isum, ircount,   &
     &        nrcount, i, j, k, l, ij, kl, lmax, mfilling, ia

      real(dblprec) FLA
! END CB

      ! CB include 'param_greens'
      ! CB include 'common_greens'
      logical exV,exVX,exBKT


!     ----------------------------------------------------------- reading the bucket file -----------------
!
      inquire(file=BKTname,exist=exBKT)
      if (.not.exBKT) then
        write(iout,*) &
     &    'sr readvijkl: V-bucket file not found: ', &
     &                            BKTname
        stop
      else
        if (icheck.lt.1) goto 100
        write(iout,*)' '
        write(iout,*)'---------------------------------------'
        write(iout,*) &
     &    'sr readvijkl: transformed Vijkl file found: ', &
     &                            BKTname
         write(iout,*)'   going to open it:'
 100     continue
      end if

      open(unit=iBKTfile,file=BKTname, &
     & STATUS='old',err=711)
      goto 712
 711  write(iout,*)'sr readvijkl: error opening file ',BKTname
      stop
 712  continue
      write(iout,*)'   opened successfully ',BKTname

      read(iBKTfile,*)idone
      if (idone.gt.1) then
        write(iout,*)'idone>1 found: idone=',idone
        write(iout,*)'=> restricted band structure calculation '
        write(iout,*)'   will be done'
        read(iBKTfile,*)mefforb,morb,istartband,iendband,mcele
        ncele=mcele
        nefforb=mefforb
        if (norb.ne.morb) then
          write(iout,*)'SR readvijkl: norb<>morb:',norb,morb
          write(iout,*)'=> STOP STOP STOP'
          stop
        end if
        ioffset=(istartband-1)*ncele
        ibandrange=(iendband-istartband+1)*ncele
        write(iout,*)' '
        write(iout,*)'** KEEP AN EYE ON THIS:'
        write(iout,*)'ioffset,ibandrange=',ioffset,ibandrange
        write(iout,*)' '
        goto 278
      end if
      if (idone.ne.1) then
        write(iout,*)'SR readvijkl: file VB.. messed up'
        write(iout,*)'            idone<>1:',idone
        stop
      end if
 278  continue
      write(iout,*) &
     &       'sr readvijkl: nefforb,norb,istartband,iendband,ncele='
      write(iout,*)nefforb,norb,istartband,iendband,ncele

!       ----------------setting the orbital-limits---------------
        if (ncele.gt.1) then
          write(iout,*)'SR readvijkl: ncele>1!!'
          write(iout,*)'   => not a supercell-formulation!!'
          write(iout,*)'   =>STOP'
          stop
        end if
        neffocca=istartband*ncele
        neffocce=nocc*ncele
        neffvirta=neffocce+1
        neffvirte=iendband*ncele
        write(iout,*)'sr readvijkl: neffocca, neffocce: = ', &
     &                              neffocca,neffocce
        write(iout,*)'              neffvirta,neffvirte:= ', &
     &                              neffvirta,neffvirte
        write(iout,*)' '
!       ---------------------------------------------------------
      read(iBKTfile,*)nN1,nNORB,FLA
      write(iout,*)'idone,nN1,nNORB,FLA are read to be:'
      write(iout,*)idone,nN1,nNORB,FLA
      if (nn1.ne.nbas) then
        write(iout,*)'** SR readvijkl: basisnr. inconsistent in'
        write(iout,*)'      fock and V files:'
        write(iout,*)'nbas,nn1= ',nbas,nn1
        write(iout,*)' ==>> STOP'
        stop
      end if
      if (nnorb.ne.norb) then
        write(iout,*)'** SR readvijkl: orbnr. inconsistent in'
        write(iout,*)'      fock and V files:'
        write(iout,*)'norb,nnorb= ',norb,nnorb
        write(iout,*)' ==>> STOP'
        stop
      end if
      ifla=int(fla)
      nijklo=ifla

      ifilldim=nbasmred*(nbasmred+1)/2
      read(ibktfile,*)mfilling,mijklx
      write(iout,*)'mfilling,mijklx=',mfilling,mijklx
      if (mfilling.gt.ifilldim) then
        write(iout,*)'sr readvijkl: BAD LUCK'
        write(iout,*)'mfilling > ifilldim:'
        write(iout,*)mfilling,ifilldim
        write(iout,*)'=> STOP'
        stop
      end if
      write(iout,*) &
     &       'sr readvijkl: reading fillings of the record entries:'
      do if=1,mfilling
        read(ibktfile,*)ifillarray(if)
        write(iout,*)'if,ifillarray=',if,ifillarray(if)
      end do

      goto 578
 577  write(iout,*)'error reading the fock file ',BKTname
      stop
 578  continue
      if (icheck.lt.1) goto 110
      write(iout,*)'   end reading Vbucket'
      write(iout,*)'---------------------------------------'
      write(iout,*)' '
 110  continue
      close(iBKTfile,status='keep')

!     ---------------------------------------------------------- opening Vijkl  -----------------

      inquire(file=Vname,exist=exV)
      if (.not.exV) then
        write(iout,*) &
     &    'sr readvijkl: transformed Vijkl file not found: ', &
     &                            Vname
        stop
      else
        if (icheck.lt.1) goto 120
        write(iout,*)' '
        write(iout,*)'---------------------------------------'
        write(iout,*) &
     &    'sr readvijkl: transformed Vijkl file found: ', &
     &                            Vname
         write(iout,*)'   going to open it:'
 120     continue
      end if

      OPEN(UNIT=iVfile,FILE=Vname,FORM='UNFORMATTED',STATUS='old', &
     &     ACCESS='DIRECT',RECL=mijklx*8,err=811)
      open(unit=iVXfile,file=VXname,FORM='UNFORMATTED', &
     & STATUS='old',ACCESS='DIRECT',RECL=mijklx*8,err=811)
      goto 812
 811  write(iout,*)'sr readvijkl: error opening file ',Vname
      stop
 812  continue
      write(iout,*)'   opened successfully ',Vname

      goto 678
 677  write(iout,*)'error reading Vijkl file ',Vname
      stop
 678  continue

!     ---------------------------------opening  VINDEX  -----------------
      inquire(file=Vname,exist=exVX)
      if (.not.exVX) then
        write(iout,*) &
     &    'sr readvijkl: Index file not found: ', &
     &                            VXname
        stop
      else
        if (icheck.lt.1) goto 130
        write(iout,*)' '
        write(iout,*)'----------------'
        write(iout,*) &
     &    'sr readvijkl: Index file found: ', &
     &                            VXname
         write(iout,*)'   going to open it:'
 130     continue
      end if

      OPEN(UNIT=iVXfile,FILE=VXname,FORM='UNFORMATTED',STATUS='old', &
     &     ACCESS='DIRECT',RECL=mijklx*8,err=911)
      goto 912
 911  write(iout,*)'sr readvijkl: error opening file ',VXname
      stop
 912  continue
      write(iout,*)'   opened successfully ',VXname

      goto 478
 477  write(iout,*)'error reading the fock file ',VXname
      stop
 478  continue
!---------------------------------------------------------------------------
      irecstart(1)=1
      isum=0
      ircount=0
      nrcount=0
      do i=1,mfilling
        ia=ifillarray(i)
        if (isum+ia.gt.mijklx) then
          ircount=ircount+1
          irecend(ircount)=i-1
          irecstart(ircount+1)=i
          isum=ia
        else
          isum=isum+ia
        endif
      end do
      ircount=ircount+1
      nrcount=ircount
      if (nrcount.gt.10*ncellm) then
        write(iout,*)'SR readvijkl: BAD LUCK: too many splittings of'
        write(iout,*)'file VijklD necessary. nrcount>10*ncellm:'
        write(iout,*)nrcount,10*ncellm
        write(iout,*)'=> STOP'
        stop
      end if
      irecend(ircount)=mfilling
      write(iout,*)' '
      write(iout,*)' -------- V-records organized as follows ---------'
      write(iout,*)'charge #, recordstart, recordend in V-file:'
      do i=1,nrcount
        write(iout,*)i,irecstart(i),irecend(i)
      end do
      write(iout,*)' '

      if (nrcount.gt.1) then
        write(iout,*)'SR readvijkl: nrcount>1: ',nrcount
        write(iout,*)'   => not all Vijkl can be read at once'
        write(iout,*)'   => STOP STOP'
        stop
      end if

      write(iout,*)'now calling get..'
      call getvijkl(mijklx,nrcount)
      write(iout,*)'sr readvijkl: now back from get..'
!      stop 'preliminary stop in readvijkl'
!---------------------------------------------------------------------------
      if (icheck.lt.1) goto 140
      write(iout,*)' end reading VINDEX'
      write(iout,*)'----------------'
      write(iout,*)' '
 140  continue
      close(iVXfile,status='keep')
      if (icheck.lt.1) goto 150
      write(iout,*)'   end reading Vijkl'
      write(iout,*)'---------------------------------------'
      write(iout,*)' '
 150  continue
      close(iVfile,status='keep')

      if (icheck.lt.2) goto 160
      write(iout,*)' '
      write(iout,*)' non-zero diagonal integrals Vikkk:'
      write(iout,*)' '
      ij=0
!      do i=1,norb
      do i=1,3
      do j=1,i
      ij=ij+1
      kl=0
      do k=1,i
      lmax=k
      if (k.eq.i) lmax=j
      do l=1,lmax
         write(iout,*)i,j,k,l,gfind(i,j,k,l)
!        v=gfind(i,k,k,k)
!        if(v.ne.0)write(iout,*)i,k,k,k,v
      end do
      end do
      end do
      end do
      write(iout,*)' '
      write(iout,*)' '
 160  continue

      end subroutine readvijkl
