!
! unpack2 --- unpack kompressed two-index indices into two
!       individual indices
! Martin Albrecht
!
!
! Copyright (c) 2003 Martin Albrecht
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!


!     INPUT    SYMMETRISIERTER INDEX  IJ
!     OUTPUT    I  UND  J

      subroutine unpack2(IJ,I,J)
      use fortrantl
      use Vintegrals
      implicit none

      integer IJ,I,J
      real(dblprec) r1

      ! I=(DSQRT(DFLOAT(2*IJ)+0.25D0)+0.4999D0)
      r1 = 2 * IJ
      r1 = r1 + 0.25D0
      r1 = sqrt(r1) + 0.4999D0
      I = int(r1)

      J = IJ - (I * (I-1)) / 2
      end subroutine unpack2
