!
! typeswannier --- Provide types for the Wannier program
! Christian Buth
! 27.02.2004
!
!
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!


      module typeswannier
      use lattice
      implicit none

      type twannier
        integer numOrbitals,          &         ! Number of Hartree-Fock bands
     &          numOccupied,          &         ! Number of virtual Hartree-Fock bands
     &          numVirtual,           &         ! Number of occupied Hartree-Fock bands
     &          startOccupied,        &         ! First occupied band
     &          endVirtual,           &         ! Last virtual band
     &          numUnitCells,         &         ! Number of unit cells transformed from AO to CO
     &          numClusterUnitCells,  &         ! Number of unit cells used for the Wannier cluster
     &          numFockAllUnitCells,  &         ! Number of unit cells to be used to construct the FOCKALL matrices
     &          periodicity

        type(tlatticeindex), pointer :: idirect(:)     ! Direct lattice indices
        type(tlatticevector), pointer :: cdirect(:)    ! Cartesian direct lattice vectors
      end type twannier
      end module typeswannier
